Attribute VB_Name = "modConsoleOperation"
'Konsole ffnen
Public Function OpenConsole() As Boolean
    On Error GoTo ErrorHandler
    
    If FileExists(SysDir & "cmd.exe") = True Then
        DosConsoleFilename = SysDir & "cmd.exe"
    End If
    
    If FileExists(SysDir & "command.exe") = True Then
        DosConsoleFilename = SysDir & "command.com"
    End If
        
    Do Until FindWindow(vbNullString, DosConsoleFilename) = 0
        PostMessage FindWindow(vbNullString, DosConsoleFilename), &H10, 0&, 0&
        DoEvents
    Loop
    
    Dim Result As Long
    
    'Alternativ: Versteckt ausfhren
    'Result = ShellExecute(0, "Open", DosConsoleFilename, vbNullString, vbNullString, SW_HIDE)
    
    Result = ShellExecute(0, "Open", DosConsoleFilename, vbNullString, vbNullString, SW_SHOWNORMAL)
    
    DoEvents
    
    If Result = 0 Then
        OpenConsole = False
        Exit Function
    End If
    
    ConsoleWindowHandle = FindWindow(vbNullString, DosConsoleFilename)
    DoEvents
    
    If ConsoleWindowHandle = 0 Then
        OpenConsole = False
        Exit Function
    End If
    
    ReDim MenuList(0)
      
    Call List_Menu(ConsoleWindowHandle, 0, True)
        
    Call GetMenuHandles
    
    If ParentMenuHandle <> 0 Then
        If MenuMarkAllHandle <> 0 Then
            If MenuCopyHandle <> 0 Then
                OpenConsole = True
            End If
        End If
    End If
    
    Exit Function
ErrorHandler:
    OpenConsole = False
    Exit Function
End Function

'In die Konsole tippen
Public Sub TypeConsole(TypeString As String)
    If Right$(TypeString, 1) <> vbCrLf Then
        TypeString = TypeString & vbCrLf
        ParameterString = TypeString
    End If
    
    Dim CharCounter As Long
    For CharCounter = 1 To Len(TypeString)
        SendMessage ConsoleWindowHandle, WM_KEYDOWN, &H62, 0
        SendMessage ConsoleWindowHandle, WM_CHAR, Asc(Mid$(TypeString, CharCounter, 1)), 0
        SendMessage ConsoleWindowHandle, WM_KEYUP, &H62, 0
        DoEvents
    Next CharCounter
    DoEvents
End Sub

'Konsole auslesen
Public Function GetConsole() As String
    
    'Eventuell mssen die Wartezeiten in dieser Prozedur verlngert werden, sonst kommt es zu Fehlern mit der Zwischenablage.
    'Bei meinen Test funktioniert alles einwandfrei.
    'Ich habe leider keine Mglichkeit auf einem langsamen Rechner zu testen.
    
    Dim RememberClipboardText As String
    
    If Clipboard.GetText <> vbNullString Then
        RememberClipboardText = Clipboard.GetText
        DoEvents
    End If
    DoEvents
    
    Call SendMessage(ParentMenuHandle, WM_SYSCOMMAND, MenuMarkAllHandle, 0)
    DoEvents
    Wait 20
    Call SendMessage(ParentMenuHandle, WM_SYSCOMMAND, MenuCopyHandle, 0)
    DoEvents
    Wait 20
    
    GetConsole = Clipboard.GetText
    DoEvents
    Wait 20
    
    If RememberClipboardText = vbNullString Then
        Clipboard.Clear
    Else
        Clipboard.SetText RememberClipboardText
    End If
    DoEvents
    Wait 20
End Function

'Konsole schliessen
Public Sub CloseConsole()
    PostMessage ConsoleWindowHandle, &H10, 0&, 0&
End Sub
